package com.example.kazuhirokondou.androidsextant;

import android.content.Context;
import android.content.Intent;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

import java.util.List;

public class CustomAdapter extends ArrayAdapter <CustomData>{
    private static final String DEBUG_TAG = "CustomAd::";

	private LayoutInflater layoutInflater_;
    private Context cn;
	public CustomAdapter(Context context, int textViewResourceId, List <CustomData>objects) {
		super(context, textViewResourceId, objects);
		// コンストラクタでContextをcnに格納
		layoutInflater_ = (LayoutInflater) context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
		cn = context;
	}
	@Override
	public View getView(int position,View convertView,ViewGroup parent){
        final String METHOD_TAG = "getView";
//        Log.d(DEBUG_TAG + METHOD_TAG, "開始");
		//特定の行（position）のデータを得る
		final CustomData item = getItem(position);

		//convertViewは使い回しされている可能性があるのでNullの時だけ新しく作る
		if(null == convertView){
			convertView = layoutInflater_.inflate(R.layout.grid_pannel, null);
		}
		
		//CustomDataのデータをViewの各widgetにセットする
        //共通背景色の設定
        int color_id = cn.getResources().getIdentifier(item.getGridColor(),"color", cn.getPackageName());
        int color_val = cn.getResources().getColor(color_id);
        Log.d(DEBUG_TAG + METHOD_TAG,"getGridColor():"+item.getGridColor());
        Log.d(DEBUG_TAG + METHOD_TAG,"color_val:"+color_val);

        //panelIconを設定
		ImageView imageView;
		imageView = (ImageView)convertView.findViewById(R.id.gridImage);
		imageView.setImageBitmap(item.getImageData());
        imageView.setBackgroundColor(color_val);

		//panelTitleを設定
        //文字色は白に固定
		TextView titleView;
		titleView = (TextView)convertView.findViewById(R.id.gridTitle);
		titleView.setText(item.getTitleData());
        titleView.setTextColor(cn.getResources().getColor(R.color.White));
        titleView.setBackgroundColor(color_val);

        //各パネルの背景色はList指定の配色にしたい為、文言でリソースを検索する
        LinearLayout ll;
        ll = (LinearLayout)convertView.findViewById(R.id.gridLayout);
        ll.setBackgroundColor(color_val);

        //パネルをクリック時にIntent発行し各機能Activityを呼び出し
        convertView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                String s;
                Intent it = new Intent(cn,MainActivity.class);
                s = cn.getPackageName()+"."+item.getIntentActivityName();
                it.setClassName(cn.getPackageName(),s);
                cn.startActivity(it);
            }
        });
        return convertView;
	}
}
