package com.example.kazuhirokondou.androidsextant;

import android.content.Context;
import android.content.pm.PackageManager;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.Bundle;
import android.support.v7.app.ActionBarActivity;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.GridView;

import java.util.ArrayList;
import java.util.List;


public class MainActivity extends ActionBarActivity {
    private static final String DEBUG_TAG = "MainAct:";
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        final String METHOD_TAG = "onCreate";
//        Log.d(DEBUG_TAG+METHOD_TAG, "開始");

        //ダミーデータ
        String[] panelTitle = {"六分儀","地図","モールス"};
        String[] panelColor = {"Blue","Green","Yellow"};
        String[] panelIcon ={"binoculars52","map792","wifi1022"};
        String[] panelActivityName ={"SixtantTitleActivity","OfflineMapActivity","MorseSignalTitleActivity"};

        GridView gv;
        List<CustomData> objects = new ArrayList<>();
        //GridViewへ各要素の配置
        int i =0;
        int imagID;
        Bitmap image;
        for(String s : panelTitle){
            //オブジェクト配列は単純に配列を生成するだけでは実体が無い
            //配列の個々の要素は別途Newして生成しなければjava.lang.NullPointerExceptionが発生する
            CustomData item = new CustomData();
            //パネルTitleの設定
            item.setTitleData(s);
            //パネルIconの設定
            imagID = getResources().getIdentifier(panelIcon[i], "drawable", getPackageName());
            Log.d(DEBUG_TAG+METHOD_TAG, "IconName:"+ panelIcon[i]);
            Log.d(DEBUG_TAG+METHOD_TAG, "imagID:"+ Integer.toString(imagID));
            image = BitmapFactory.decodeResource(getResources(), imagID);
            item.setImageData(image);
            //パネル背景色の設定
            item.setGridColor(panelColor[i]);
            //パネルから発行するIntent名を設定
            item.setIntentActivityName(panelActivityName[i]);
            //配列へ要素を追加
            Log.d("On_Create", "配列へ要素追加:"+panelTitle[i]);
            objects.add(item);
            i++;
        }

        //ListViewへ作成したデータをセットする
        CustomAdapter customAdapter = new CustomAdapter(this,0,objects);
        gv = (GridView)findViewById(R.id.main_gridView);
        gv.setAdapter(customAdapter);


    }


    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    @Override
    protected void onResume() {
        super.onResume();
    }

    @Override
    protected void onPause() {
        super.onPause();
    }

    /** Check if this device has a camera */
    private boolean checkCameraHardware(Context context) {
        if (context.getPackageManager().hasSystemFeature(PackageManager.FEATURE_CAMERA)){
            // this device has a camera
            return true;
        } else {
            // no camera on this device
            return false;
        }
    }}
